'use strict';

var pieces = require('@sapphire/pieces');
var enum_cjs = require('../lib/resolvers/enum.cjs');
var Argument_cjs = require('../lib/structures/Argument.cjs');

var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var _CoreArgument = class _CoreArgument extends Argument_cjs.Argument {
  constructor(context) {
    super(context, { name: "enum" });
  }
  run(parameter, context) {
    const resolved = enum_cjs.resolveEnum(parameter, { enum: context.enum, caseInsensitive: context.caseInsensitive });
    return resolved.mapErrInto(
      (identifier) => this.error({
        parameter,
        identifier,
        message: `The argument must have one of the following values: ${context.enum?.join(", ")}`,
        context
      })
    );
  }
};
__name(_CoreArgument, "CoreArgument");
var CoreArgument = _CoreArgument;
void pieces.container.stores.loadPiece({
  name: "enum",
  piece: CoreArgument,
  store: "arguments"
});

exports.CoreArgument = CoreArgument;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=CoreEnum.cjs.map