'use strict';

var pieces = require('@sapphire/pieces');
var partialDMChannel_cjs = require('../lib/resolvers/partialDMChannel.cjs');
var Argument_cjs = require('../lib/structures/Argument.cjs');

var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var _CoreArgument = class _CoreArgument extends Argument_cjs.Argument {
  constructor(context) {
    super(context, { name: "partialDMChannel" });
  }
  run(parameter, context) {
    const resolved = partialDMChannel_cjs.resolvePartialDMChannel(parameter, context.message);
    return resolved.mapErrInto(
      (identifier) => this.error({
        parameter,
        identifier,
        message: "The argument did not resolve to a Partial DM channel.",
        context
      })
    );
  }
};
__name(_CoreArgument, "CoreArgument");
var CoreArgument = _CoreArgument;
void pieces.container.stores.loadPiece({
  name: "partialDMChannel",
  piece: CoreArgument,
  store: "arguments"
});

exports.CoreArgument = CoreArgument;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=CorePartialDMChannel.cjs.map