'use strict';

var discord_jsUtilities = require('@sapphire/discord.js-utilities');
var result = require('@sapphire/result');
var Identifiers_cjs = require('../errors/Identifiers.cjs');
var channel_cjs = require('./channel.cjs');

var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
function resolveDMChannel(parameter, messageOrInteraction) {
  const result$1 = channel_cjs.resolveChannel(parameter, messageOrInteraction);
  return result$1.mapInto((value) => {
    if (discord_jsUtilities.isDMChannel(value) && !value.partial) {
      return result.Result.ok(value);
    }
    return result.Result.err(Identifiers_cjs.Identifiers.ArgumentDMChannelError);
  });
}
__name(resolveDMChannel, "resolveDMChannel");

exports.resolveDMChannel = resolveDMChannel;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=dmChannel.cjs.map