'use strict';

var result = require('@sapphire/result');
var Identifiers_cjs = require('../errors/Identifiers.cjs');

var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
function resolveEnum(parameter, options) {
  if (!options?.enum?.length) {
    return result.Result.err(Identifiers_cjs.Identifiers.ArgumentEnumEmptyError);
  }
  if (!options.caseInsensitive && !options.enum.includes(parameter)) {
    return result.Result.err(Identifiers_cjs.Identifiers.ArgumentEnumError);
  }
  if (options.caseInsensitive && !options.enum.some((v) => v.toLowerCase() === parameter.toLowerCase())) {
    return result.Result.err(Identifiers_cjs.Identifiers.ArgumentEnumError);
  }
  return result.Result.ok(parameter);
}
__name(resolveEnum, "resolveEnum");

exports.resolveEnum = resolveEnum;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=enum.cjs.map