'use strict';

var discordUtilities = require('@sapphire/discord-utilities');
var pieces = require('@sapphire/pieces');
var result = require('@sapphire/result');
var Identifiers_cjs = require('../errors/Identifiers.cjs');

var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
async function resolveGuild(parameter) {
  const guildId = discordUtilities.SnowflakeRegex.exec(parameter)?.groups?.id;
  const guild = guildId ? await pieces.container.client.guilds.fetch(guildId).catch(() => null) : null;
  if (guild) {
    return result.Result.ok(guild);
  }
  return result.Result.err(Identifiers_cjs.Identifiers.ArgumentGuildError);
}
__name(resolveGuild, "resolveGuild");

exports.resolveGuild = resolveGuild;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=guild.cjs.map