'use strict';

var result = require('@sapphire/result');
var Identifiers_cjs = require('../errors/Identifiers.cjs');

var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
function resolveString(parameter, options) {
  if (typeof options?.minimum === "number" && parameter.length < options.minimum) {
    return result.Result.err(Identifiers_cjs.Identifiers.ArgumentStringTooShort);
  }
  if (typeof options?.maximum === "number" && parameter.length > options.maximum) {
    return result.Result.err(Identifiers_cjs.Identifiers.ArgumentStringTooLong);
  }
  return result.Result.ok(parameter);
}
__name(resolveString, "resolveString");

exports.resolveString = resolveString;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=string.cjs.map