'use strict';

var pieces = require('@sapphire/pieces');

var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var _ListenerLoaderStrategy = class _ListenerLoaderStrategy extends pieces.LoaderStrategy {
  onLoad(_store, piece) {
    const listenerCallback = piece["_listener"];
    if (listenerCallback) {
      const emitter = piece.emitter;
      const maxListeners = emitter.getMaxListeners();
      if (maxListeners !== 0)
        emitter.setMaxListeners(maxListeners + 1);
      emitter[piece.once ? "once" : "on"](piece.event, listenerCallback);
    }
  }
  onUnload(_store, piece) {
    const listenerCallback = piece["_listener"];
    if (!piece.once && listenerCallback) {
      const emitter = piece.emitter;
      const maxListeners = emitter.getMaxListeners();
      if (maxListeners !== 0)
        emitter.setMaxListeners(maxListeners - 1);
      emitter.off(piece.event, listenerCallback);
      piece["_listener"] = null;
    }
  }
};
__name(_ListenerLoaderStrategy, "ListenerLoaderStrategy");
var ListenerLoaderStrategy = _ListenerLoaderStrategy;

exports.ListenerLoaderStrategy = ListenerLoaderStrategy;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=ListenerLoaderStrategy.cjs.map