'use strict';

var pieces = require('@sapphire/pieces');
var Listener_cjs = require('../lib/structures/Listener.cjs');
var Events_cjs = require('../lib/types/Events.cjs');
var ApplicationCommandRegistries_cjs = require('../lib/utils/application-commands/ApplicationCommandRegistries.cjs');

var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var _CoreListener = class _CoreListener extends Listener_cjs.Listener {
  constructor(context) {
    super(context, { event: Events_cjs.Events.ClientReady, once: true });
  }
  async run() {
    this.container.client.id ??= this.container.client.user?.id ?? null;
    await ApplicationCommandRegistries_cjs.handleRegistryAPICalls();
  }
};
__name(_CoreListener, "CoreListener");
var CoreListener = _CoreListener;
void pieces.container.stores.loadPiece({
  name: "CoreReady",
  piece: CoreListener,
  store: "listeners"
});

exports.CoreListener = CoreListener;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=CoreReady.cjs.map