'use strict';

var Listener_cjs = require('../../lib/structures/Listener.cjs');
var Events_cjs = require('../../lib/types/Events.cjs');

var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var _CoreListener = class _CoreListener extends Listener_cjs.Listener {
  constructor(context) {
    super(context, { event: Events_cjs.Events.CommandAutocompleteInteractionError });
  }
  run(error, context) {
    const { name, location } = context.command;
    this.container.logger.error(
      `Encountered error while handling an autocomplete run method on command "${name}" at path "${location.full}"`,
      error
    );
  }
};
__name(_CoreListener, "CoreListener");
var CoreListener = _CoreListener;

exports.CoreListener = CoreListener;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=CoreCommandAutocompleteInteractionError.cjs.map