import { __name } from '../chunk-G5GHKT7C.mjs';
import { container } from '@sapphire/pieces';
import { resolveEnum } from '../lib/resolvers/enum.mjs';
import { Argument } from '../lib/structures/Argument.mjs';

var _CoreArgument = class _CoreArgument extends Argument {
  constructor(context) {
    super(context, { name: "enum" });
  }
  run(parameter, context) {
    const resolved = resolveEnum(parameter, { enum: context.enum, caseInsensitive: context.caseInsensitive });
    return resolved.mapErrInto(
      (identifier) => this.error({
        parameter,
        identifier,
        message: `The argument must have one of the following values: ${context.enum?.join(", ")}`,
        context
      })
    );
  }
};
__name(_CoreArgument, "CoreArgument");
var CoreArgument = _CoreArgument;
void container.stores.loadPiece({
  name: "enum",
  piece: CoreArgument,
  store: "arguments"
});

export { CoreArgument };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=CoreEnum.mjs.map