import { __name } from '../../chunk-G5GHKT7C.mjs';
import { Result } from '@sapphire/result';
import { Identifiers } from '../errors/Identifiers.mjs';

function resolveEnum(parameter, options) {
  if (!options?.enum?.length) {
    return Result.err(Identifiers.ArgumentEnumEmptyError);
  }
  if (!options.caseInsensitive && !options.enum.includes(parameter)) {
    return Result.err(Identifiers.ArgumentEnumError);
  }
  if (options.caseInsensitive && !options.enum.some((v) => v.toLowerCase() === parameter.toLowerCase())) {
    return Result.err(Identifiers.ArgumentEnumError);
  }
  return Result.ok(parameter);
}
__name(resolveEnum, "resolveEnum");

export { resolveEnum };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=enum.mjs.map