import { __name } from '../../chunk-G5GHKT7C.mjs';
import { Result } from '@sapphire/result';
import { Identifiers } from '../errors/Identifiers.mjs';

function resolveFloat(parameter, options) {
  const parsed = Number(parameter);
  if (Number.isNaN(parsed)) {
    return Result.err(Identifiers.ArgumentFloatError);
  }
  if (typeof options?.minimum === "number" && parsed < options.minimum) {
    return Result.err(Identifiers.ArgumentFloatTooSmall);
  }
  if (typeof options?.maximum === "number" && parsed > options.maximum) {
    return Result.err(Identifiers.ArgumentFloatTooLarge);
  }
  return Result.ok(parsed);
}
__name(resolveFloat, "resolveFloat");

export { resolveFloat };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=float.mjs.map