import { __name } from '../../chunk-G5GHKT7C.mjs';
import { ChannelMentionRegex, SnowflakeRegex } from '@sapphire/discord-utilities';
import { Result } from '@sapphire/result';
import { Identifiers } from '../errors/Identifiers.mjs';

function resolveGuildChannel(parameter, guild) {
  const channel = resolveById(parameter, guild) ?? resolveByQuery(parameter, guild);
  if (channel) {
    return Result.ok(channel);
  }
  return Result.err(Identifiers.ArgumentGuildChannelError);
}
__name(resolveGuildChannel, "resolveGuildChannel");
function resolveById(argument, guild) {
  const channelId = ChannelMentionRegex.exec(argument) ?? SnowflakeRegex.exec(argument);
  return channelId ? guild.channels.cache.get(channelId[1]) ?? null : null;
}
__name(resolveById, "resolveById");
function resolveByQuery(argument, guild) {
  const lowerCaseArgument = argument.toLowerCase();
  return guild.channels.cache.find((channel) => channel.name.toLowerCase() === lowerCaseArgument) ?? null;
}
__name(resolveByQuery, "resolveByQuery");

export { resolveGuildChannel };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=guildChannel.mjs.map