import { __name } from '../../chunk-G5GHKT7C.mjs';
import { Result } from '@sapphire/result';
import { Identifiers } from '../errors/Identifiers.mjs';

function resolveNumber(parameter, options) {
  const parsed = Number(parameter);
  if (Number.isNaN(parsed)) {
    return Result.err(Identifiers.ArgumentNumberError);
  }
  if (typeof options?.minimum === "number" && parsed < options.minimum) {
    return Result.err(Identifiers.ArgumentNumberTooSmall);
  }
  if (typeof options?.maximum === "number" && parsed > options.maximum) {
    return Result.err(Identifiers.ArgumentNumberTooLarge);
  }
  return Result.ok(parsed);
}
__name(resolveNumber, "resolveNumber");

export { resolveNumber };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=number.mjs.map