import { __name } from '../../chunk-G5GHKT7C.mjs';
import { UserOrMemberMentionRegex, SnowflakeRegex } from '@sapphire/discord-utilities';
import { container } from '@sapphire/pieces';
import { Result } from '@sapphire/result';
import { Identifiers } from '../errors/Identifiers.mjs';

async function resolveUser(parameter) {
  const userId = UserOrMemberMentionRegex.exec(parameter) ?? SnowflakeRegex.exec(parameter);
  const user = userId ? await container.client.users.fetch(userId[1]).catch(() => null) : null;
  if (user) {
    return Result.ok(user);
  }
  return Result.err(Identifiers.ArgumentUserError);
}
__name(resolveUser, "resolveUser");

export { resolveUser };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=user.mjs.map