import { __name } from '../../chunk-G5GHKT7C.mjs';
import { Listener } from '../../lib/structures/Listener.mjs';
import { Events } from '../../lib/types/Events.mjs';

var _CoreListener = class _CoreListener extends Listener {
  constructor(context) {
    super(context, { event: Events.CommandAutocompleteInteractionError });
  }
  run(error, context) {
    const { name, location } = context.command;
    this.container.logger.error(
      `Encountered error while handling an autocomplete run method on command "${name}" at path "${location.full}"`,
      error
    );
  }
};
__name(_CoreListener, "CoreListener");
var CoreListener = _CoreListener;

export { CoreListener };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=CoreCommandAutocompleteInteractionError.mjs.map