'use strict';

require('tslib');
var LoaderError_cjs = require('./lib/errors/LoaderError.cjs');
var MissingExportsError_cjs = require('./lib/errors/MissingExportsError.cjs');
var RootScan_cjs = require('./lib/internal/RootScan.cjs');
var constants_cjs = require('./lib/internal/constants.cjs');
var Container_cjs = require('./lib/shared/Container.cjs');
var ILoaderStrategy_cjs = require('./lib/strategies/ILoaderStrategy.cjs');
var LoaderStrategy_cjs = require('./lib/strategies/LoaderStrategy.cjs');
var AliasPiece_cjs = require('./lib/structures/AliasPiece.cjs');
var AliasStore_cjs = require('./lib/structures/AliasStore.cjs');
var Piece_cjs = require('./lib/structures/Piece.cjs');
var PieceLocation_cjs = require('./lib/structures/PieceLocation.cjs');
var Store_cjs = require('./lib/structures/Store.cjs');
var StoreRegistry_cjs = require('./lib/structures/StoreRegistry.cjs');



Object.defineProperty(exports, "VirtualPath", {
  enumerable: true,
  get: function () { return constants_cjs.VirtualPath; }
});
Object.keys(LoaderError_cjs).forEach(function (k) {
  if (k !== 'default' && !Object.prototype.hasOwnProperty.call(exports, k)) Object.defineProperty(exports, k, {
    enumerable: true,
    get: function () { return LoaderError_cjs[k]; }
  });
});
Object.keys(MissingExportsError_cjs).forEach(function (k) {
  if (k !== 'default' && !Object.prototype.hasOwnProperty.call(exports, k)) Object.defineProperty(exports, k, {
    enumerable: true,
    get: function () { return MissingExportsError_cjs[k]; }
  });
});
Object.keys(RootScan_cjs).forEach(function (k) {
  if (k !== 'default' && !Object.prototype.hasOwnProperty.call(exports, k)) Object.defineProperty(exports, k, {
    enumerable: true,
    get: function () { return RootScan_cjs[k]; }
  });
});
Object.keys(Container_cjs).forEach(function (k) {
  if (k !== 'default' && !Object.prototype.hasOwnProperty.call(exports, k)) Object.defineProperty(exports, k, {
    enumerable: true,
    get: function () { return Container_cjs[k]; }
  });
});
Object.keys(ILoaderStrategy_cjs).forEach(function (k) {
  if (k !== 'default' && !Object.prototype.hasOwnProperty.call(exports, k)) Object.defineProperty(exports, k, {
    enumerable: true,
    get: function () { return ILoaderStrategy_cjs[k]; }
  });
});
Object.keys(LoaderStrategy_cjs).forEach(function (k) {
  if (k !== 'default' && !Object.prototype.hasOwnProperty.call(exports, k)) Object.defineProperty(exports, k, {
    enumerable: true,
    get: function () { return LoaderStrategy_cjs[k]; }
  });
});
Object.keys(AliasPiece_cjs).forEach(function (k) {
  if (k !== 'default' && !Object.prototype.hasOwnProperty.call(exports, k)) Object.defineProperty(exports, k, {
    enumerable: true,
    get: function () { return AliasPiece_cjs[k]; }
  });
});
Object.keys(AliasStore_cjs).forEach(function (k) {
  if (k !== 'default' && !Object.prototype.hasOwnProperty.call(exports, k)) Object.defineProperty(exports, k, {
    enumerable: true,
    get: function () { return AliasStore_cjs[k]; }
  });
});
Object.keys(Piece_cjs).forEach(function (k) {
  if (k !== 'default' && !Object.prototype.hasOwnProperty.call(exports, k)) Object.defineProperty(exports, k, {
    enumerable: true,
    get: function () { return Piece_cjs[k]; }
  });
});
Object.keys(PieceLocation_cjs).forEach(function (k) {
  if (k !== 'default' && !Object.prototype.hasOwnProperty.call(exports, k)) Object.defineProperty(exports, k, {
    enumerable: true,
    get: function () { return PieceLocation_cjs[k]; }
  });
});
Object.keys(Store_cjs).forEach(function (k) {
  if (k !== 'default' && !Object.prototype.hasOwnProperty.call(exports, k)) Object.defineProperty(exports, k, {
    enumerable: true,
    get: function () { return Store_cjs[k]; }
  });
});
Object.keys(StoreRegistry_cjs).forEach(function (k) {
  if (k !== 'default' && !Object.prototype.hasOwnProperty.call(exports, k)) Object.defineProperty(exports, k, {
    enumerable: true,
    get: function () { return StoreRegistry_cjs[k]; }
  });
});
//# sourceMappingURL=out.js.map
//# sourceMappingURL=index.cjs.map