'use strict';

var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });

// src/lib/retry.ts
async function retry(cb, retries) {
  if (retries < 0)
    throw new RangeError("Expected retries to be a number >= 0");
  if (retries === 0)
    return cb();
  let lastError;
  for (let i = 0; i < retries; ++i) {
    try {
      return await cb();
    } catch (error) {
      lastError = error;
    }
  }
  throw lastError;
}
__name(retry, "retry");

exports.retry = retry;
//# sourceMappingURL=out.js.map
//# sourceMappingURL=retry.cjs.map