import { __name } from '../chunk-G5GHKT7C.mjs';

// src/lib/retrySync.ts
function retrySync(cb, retries) {
  if (retries < 0)
    throw new RangeError("Expected retries to be a number >= 0");
  if (retries === 0)
    return cb();
  let lastError;
  for (let i = 0; i < retries; ++i) {
    try {
      return cb();
    } catch (error) {
      lastError = error;
    }
  }
  throw lastError;
}
__name(retrySync, "retrySync");

export { retrySync };
//# sourceMappingURL=out.js.map
//# sourceMappingURL=retrySync.mjs.map